<!DOCTYPE html>
<html lang="fr">
<head>
    <meta charset="UTF-8">
    <title>Coloriage Interactif d'un sphere 3D</title>
    <style>
        body { margin: 0; }
        canvas { display: block; }
    </style>
    <script type="importmap">
        {
            "imports": {
                "three": "https://cdn.jsdelivr.net/npm/three@0.153.0/build/three.module.js",
                "three/examples/jsm/controls/OrbitControls.js": "https://cdn.jsdelivr.net/npm/three@0.153.0/examples/jsm/controls/OrbitControls.js",
                "three/examples/jsm/loaders/GLTFLoader.js": "https://cdn.jsdelivr.net/npm/three@0.153.0/examples/jsm/loaders/GLTFLoader.js"}
        }
      </script>
</head>
<body>
    <script type="module">
        //import * as THREE from 'three'
        import * as THREE from 'https://cdn.jsdelivr.net/npm/three@0.153.0/build/three.module.js';
        import { OrbitControls } from 'three/examples/jsm/controls/OrbitControls.js';
        import { GLTFLoader } from 'three/examples/jsm/loaders/GLTFLoader.js';

        /*import * as THREE from 'https://cdn.skypack.dev/three@0.150.0';
        import { OrbitControls } from 'https://cdn.skypack.dev/three@0.150.0/examples/jsm/controls/OrbitControls.js';
        import { GLTFLoader } from 'https://cdn.skypack.dev/three@0.150.0/examples/jsm/loaders/GLTFLoader.js';*/

        let scene = new THREE.Scene();
        let camera = new THREE.PerspectiveCamera(75, window.innerWidth / window.innerHeight, 0.1, 1000);
        let renderer = new THREE.WebGLRenderer({ antialias: true });
        renderer.shadowMap.enabled = true;
        renderer.shadowMap.type = THREE.PCFSoftShadowMap; // default THREE.PCFShadowMap
        renderer.setSize(window.innerWidth, window.innerHeight);
        document.body.appendChild(renderer.domElement);

        const light = new THREE.DirectionalLight( 0xffffff, 1 );
        light.position.set( 1, 1, 0 ); //default; light shining from top
        light.castShadow = true; // default false
        scene.add( light );

        //Set up shadow properties for the light
        light.shadow.mapSize.width = 512; // default
        light.shadow.mapSize.height = 512; // default
        light.shadow.camera.near = 0.5; // default
        light.shadow.camera.far = 500; // default

        const controls = new OrbitControls(camera, renderer.domElement);
        controls.target.set(0, 0, 0); // s'assurer que les contrôles pointent vers le centre de la scène
        controls.update();
        controls.enableDamping = true; // Effet optionnel qui rend les contrôles plus pondérés
        controls.dampingFactor = 0.1;

        //Create a sphere that cast shadows (but does not receive them)
const sphereGeometry = new THREE.SphereGeometry( 3, 32, 32 );
const sphereMaterial = new THREE.MeshStandardMaterial( { color: 0xff0000 } );
const sphere2 = new THREE.Mesh( sphereGeometry, sphereMaterial );
sphere2.position.y=1;
sphere2.castShadow = true; //default is false
sphere2.receiveShadow = false; //default
scene.add( sphere2 );

//Create a plane that receives shadows (but does not cast them)
const planeGeometry = new THREE.PlaneGeometry( 20, 20, 32, 32 );
const planeMaterial = new THREE.MeshStandardMaterial( { color: 0xffffff } )
const plane = new THREE.Mesh( planeGeometry, planeMaterial );
plane.rotation.x = - Math.PI / 2;
plane.receiveShadow = true;
scene.add( plane );

        // Création de la géométrie de la sphère avec SphereBufferGeometry
        let geometry = new THREE.SphereBufferGeometry(1, 32, 32); // rayon, largeurSeg, hauteurSeg
        // Initialisation des couleurs des vertex
        const numVertices = geometry.attributes.position.count;
        const colors = new Float32Array(numVertices * 3); // trois valeurs par vertex pour R, G, B
        geometry.setAttribute('color', new THREE.BufferAttribute(colors, 3));

        for (let i = 0; i < numVertices; i++) {
            colors[i * 3] = 1;     // R
            colors[i * 3 + 1] = 1; // G
            colors[i * 3 + 2] = 1; // B
        }

        let material = new THREE.MeshBasicMaterial({ vertexColors: true });
        let sphere = new THREE.Mesh(geometry, material);
        scene.add(sphere);

        camera.position.z = 5;

        let raycaster = new THREE.Raycaster();
        let mouse = new THREE.Vector2();

        window.addEventListener('mousemove', event => {
            mouse.x = (event.clientX / window.innerWidth) * 2 - 1;
            mouse.y = -(event.clientY / window.innerHeight) * 2 + 1;
        });

        function render() {
            requestAnimationFrame(render);
            raycaster.setFromCamera(mouse, camera);
            const intersects = raycaster.intersectObject(sphere);
            if (intersects.length > 0) {
                const { face, object } = intersects[0];
                const faceVertices = [face.a, face.b, face.c];
                const colors = object.geometry.attributes.color;
                faceVertices.forEach(index => {
                    colors.setXYZ(index, Math.random(), Math.random(), Math.random());
                });
                colors.needsUpdate = true;
            }
            renderer.render(scene, camera);
        }

        render();
    </script>
</body>
</html>
